#include "misc.h"

/*  Vtg JIS  2 oCgڂǂeXg
 *
 *  yz
 *  s ---- ւ̃|C^
 *  n ---- eXg镶̈ʒui擪 0 j
 *
 *  y߂lz
 *  ^ 1 AU 0 Ԃ
 */
int is_kanji2(const char *s, int n)
{
    int i, f = 0;
    if (!IS_SJIS_KANJI2(*(s+n))) return 0;
    for (i = 0; i < n; i++) {
        if (f == 0 && IS_SJIS_KANJI1(*(s+i))) {
            f = 1;
            continue;
        }
        f = 0;
    }
    return f;
}

/*  gq̈ʒu
 *
 *  yz
 *  path ---- gq܂ރpXւ̃|C^
 *
 *  y߂lz
 *  gqꍇ́Apath ł̊gqO "." ̃AhX
 *  ȊȌꍇ́AŌ NULL ւ̃AhX
 */
char *find_ext(char *path)
{
    int i, n;
    n = strlen(path);
    if (n > 0) {
        for (i = n - 1; i >= 0; i--) {
            if (*(path+i) == '.')
                return path+i;
            else if ((*(path+i) == '\\' && is_kanji2(path, i) == 0)
                    || (*(path+i) == ':'))
                break;
        }
    }
    return path+n;
}

/*  gqύX
 *
 *  yz
 *  buf ---- gqύXt@C󂯎obt@
 *  path --- tpX
 *  ext ---- ύXgq
 *
 *  y߂lz
 *  Ŏw肵obt@ւ̃|C^
 */
char *change_ext(char *buf, const char *path, const char *ext)
{
    char *p;
    strcpy(buf, path);
    p = find_ext(buf);  
    if (*ext == '.') {
        strcpy(p, ext);
    } else {
        strcpy(p, ".");
        strcpy(p+1, ext);
    }
    return buf;
}

/*  tpXt@C菜
 *
 *  yz
 *  buf ---- t@C폜Ƃ̃pX
 *  path --- tpX
 *
 *  y߂lz
 *  Ŏw肵obt@ւ̃|C^
 */
char *extract_path(char *buf, const char *path)
{
    int i, n, r = 0;
    n = strlen(path);
    for (i = 0; i < n; i++) {
        *(buf+i) = *(path+i);
        if (*(path+i) == '\\' || *(path+i) == ':') {
            r = i + 1;
        } else if (IS_SJIS_KANJI1(*(path+i))) {
            i++;
            *(buf+i) = *(path+i);
            if (*(path+i) == '\0') break;
        }
    }
    *(buf+r) = '\0';
    return buf;
}

/*  tpXpX菜
 *
 *  yz
 *  buf ---- t@C󂯎obt@
 *  path --- tpX
 *
 *  y߂lz
 *  Ŏw肵obt@ւ̃|C^
 */
char *extract_filename(char *buf, const char *path)
{
    int i, n, r = 0;
    n = strlen(path);
    for (i = 0; i < n; i++) {
        if (*(path+i) == '\\' || *(path+i) == ':') {
            r = i + 1;
        } else if (IS_SJIS_KANJI1(*(path+i))) {
            i++;
            if (*(path+i) == '\0') break;
        }
    }
    strcpy(buf, path+r);
    return buf;
}

/*  Xg[當𓾂
 *
 *  yz
 *  buf ---- 󂯎obt@
 *  size --- ő啶ioCgj
 *
 *  yӁz
 *  obt@ buf  size Ŏw肷oCg
 *  1 oCgȏ傫mۂ邱.
 */
void input(char *buf, int size)
{
    char temp[MAXCMD+1];
    int i;
    if (fgets(temp, MAXCMD+1, stdin) != NULL)
    {
        for (i = 0; temp[i] != '\0'; i++) {
            if (temp[i] == '\n') {
                temp[i] = '\0';
                break;
            }
        }
        strncpy(buf, temp, size);
        *(buf+size) = '\0';
    }
    else
        *buf = '\0';
}
